# Generated by sila2.code_generator; sila2.__version__: 0.12.2
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from typing import Any, Iterable, List, Optional

    from connectionconfigurationservice_types import (
        ConnectSiLAClient_Responses,
        DisableServerInitiatedConnectionMode_Responses,
        DisconnectSiLAClient_Responses,
        EnableServerInitiatedConnectionMode_Responses,
    )
    from sila2.client import ClientMetadataInstance, ClientUnobservableProperty


class ConnectionConfigurationServiceClient:
    """

    This Feature MUST be implemented by each SiLA Server that offers a Server-initiated connection.

    The server-initiated connection mode is persistent, it keeps the state after a restart.
    Connect to a SiLA Client passing the required information and optionally keep the connection details persistent.
    The SiLA Server will reconnect to the persistent SiLA Clients after a restart.

    """

    ServerInitiatedConnectionModeStatus: ClientUnobservableProperty[bool]
    """
    Whether or not the server initiated connection mode is active.
    """

    ConfiguredSiLAClients: ClientUnobservableProperty[List[Any]]
    """
    
      Get the configured SiLA Clients used for server-initiated connections.
    
    """

    def EnableServerInitiatedConnectionMode(
        self, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> EnableServerInitiatedConnectionMode_Responses:
        """
        Enable the server initiated connection mode.
        """
        ...

    def DisableServerInitiatedConnectionMode(
        self, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> DisableServerInitiatedConnectionMode_Responses:
        """
        Disable the server initiated connection mode.
        """
        ...

    def ConnectSiLAClient(
        self,
        ClientName: str,
        SiLAClientHost: str,
        SiLAClientPort: int,
        Persist: bool,
        *,
        metadata: Optional[Iterable[ClientMetadataInstance]] = None,
    ) -> ConnectSiLAClient_Responses:
        """
        Connect a new SiLA Client.
        """
        ...

    def DisconnectSiLAClient(
        self, ClientName: str, Remove: bool, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> DisconnectSiLAClient_Responses:
        """
        Disconnect a configured SiLA Client.
        """
        ...
